def tokenize(input_string):
    delimiter = [
        "(",
        ")",
        ":",
        ",",
        ".",
        "=",
        "+",
        "-",
        "*",
        "/",
        "<",
        ">",
        "!",
        "&",
        "|",
        "~",
        "%",
        " ",
        "[",
        "]",
        "{",
        "}",
        "0",
        "1",
        "2",
        "3",
        "4",
        "5",
        "6",
        "7",
        "8",
        "9",
        '"',
        "\t",
    ]
    token = {
        "#": "NUMBER SIGN",
        "!": "EXCLAMATION MARK",
        "/": "SLASH",
        "\\": "BACKSLASH",
        "class_name": "CLASS NAME",
        "extends": "EXTENDS",
        "##": "NUMBER SIGN 2",
        "func": "FUNCTION",
        "(": "LEFT BRACKET",
        ")": "RIGHT BRACKET",
        "-": "MINUS",
        "+": "PLUS",
        ">": "GREATER THAN",
        "<": "LESS THAN",
        ":": "COLON",
        "=": "EQUALS SIGN",
        "{": "CURLY LEFT BRACKET",
        "}": "CURLY RIGHT BRACKET",
        "\t": "TAB",
        ".": "DOT",
        "new": "NEW",
        "var": "VARIABLE",
    }
    tokens = []
    buffer = ""
    for ch in input_string:
        if ch in delimiter:
            if buffer != "":
                tokens.append(char_to_token(buffer, token))
                buffer = ""
            if ch != " ":
                tokens.append(char_to_token(ch, token))
        else:
            buffer += ch
    if buffer != "":
        tokens.append(char_to_token(buffer, token))
    return tokens


def char_to_token(buffer, token):
    return token[buffer] if buffer in token else buffer
